<?php
include_once $_SERVER['DOCUMENT_ROOT'] . '/include/shared-manual.inc';
$TOC = array();
$TOC_DEPRECATED = array();
$PARENTS = array();
include_once dirname(__FILE__) ."/toc/class.reflectionclass.inc";
$setup = array (
  'home' => 
  array (
    0 => 'index.php',
    1 => 'PHP Manual',
  ),
  'head' => 
  array (
    0 => 'UTF-8',
    1 => 'ja',
  ),
  'this' => 
  array (
    0 => 'reflectionclass.marklazyobjectasinitialized.php',
    1 => 'ReflectionClass::markLazyObjectAsInitialized',
  ),
  'up' => 
  array (
    0 => 'class.reflectionclass.php',
    1 => 'ReflectionClass',
  ),
  'prev' => 
  array (
    0 => 'reflectionclass.isuserdefined.php',
    1 => 'ReflectionClass::isUserDefined',
  ),
  'next' => 
  array (
    0 => 'reflectionclass.newinstance.php',
    1 => 'ReflectionClass::newInstance',
  ),
  'alternatives' => 
  array (
  ),
  'source' => 
  array (
    'lang' => 'ja',
    'path' => 'reference/reflection/reflectionclass/marklazyobjectasinitialized.xml',
  ),
  'history' => 
  array (
  ),
);
$setup["toc"] = $TOC;
$setup["toc_deprecated"] = $TOC_DEPRECATED;
$setup["parents"] = $PARENTS;
manual_setup($setup);

contributors($setup);

?>
<div id="reflectionclass.marklazyobjectasinitialized" class="refentry">
 <div class="refnamediv">
  <h1 class="refname">ReflectionClass::markLazyObjectAsInitialized</h1>
  <p class="verinfo">(PHP 8 &gt;= 8.4.0)</p><p class="refpurpose"><span class="refname">ReflectionClass::markLazyObjectAsInitialized</span> &mdash; <span class="dc-title">イニシャライザまたはファクトリを呼び出さずレイジーオブジェクトを初期化済みとしてマークする</span></p>

 </div>

 <div class="refsect1 description" id="refsect1-reflectionclass.marklazyobjectasinitialized-description">
  <h3 class="title">説明</h3>
  <div class="methodsynopsis dc-description">
   <span class="modifier">public</span> <span class="methodname"><strong>ReflectionClass::markLazyObjectAsInitialized</strong></span>(<span class="methodparam"><span class="type"><a href="language.types.object.php" class="type object">object</a></span> <code class="parameter">$object</code></span>): <span class="type"><a href="language.types.object.php" class="type object">object</a></span></div>

  <p class="simpara">
   イニシャライザまたはファクトリを呼び出さずレイジーオブジェクトを
   初期化済みとしてマークします。<code class="parameter">object</code> がレイジーでないか、
   すでに初期化されている場合、このメソッドは効果がありません。
  </p>
  <p class="simpara">
   このメソッド動作は、<code class="parameter">object</code> のレイジー戦略に関わらず、
   <a href="language.oop5.lazy-objects.php#language.oop5.lazy-objects.initialization-sequence" class="link">初期化シーケンス</a>
   においてゴーストオブジェクトに対して説明されたものとほぼ同じですが、
   イニシャライザが呼び出されない点を除きます。
   その後、オブジェクトは、<span class="methodname"><a href="reflectionproperty.setrawvaluewithoutlazyinitialization.php" class="methodname">ReflectionProperty::setRawValueWithoutLazyInitialization()</a></span> または
   <span class="methodname"><a href="reflectionproperty.skiplazyinitialization.php" class="methodname">ReflectionProperty::skipLazyInitialization()</a></span> で
   既に初期化されたプロパティの値を除いて、
   <span class="methodname"><a href="reflectionclass.newinstancewithoutconstructor.php" class="methodname">ReflectionClass::newInstanceWithoutConstructor()</a></span> で作成された、
   元々レイジーでなかったオブジェクトと区別がつかなくなります。
  </p>
 </div>


 <div class="refsect1 parameters" id="refsect1-reflectionclass.marklazyobjectasinitialized-parameters">
  <h3 class="title">パラメータ</h3>
  <dl>
   
    <dt><code class="parameter">object</code></dt>
    <dd>
     <span class="simpara">
      初期化済みとしてマークするオブジェクト。
     </span>
    </dd>
   
  </dl>
 </div>


 <div class="refsect1 returnvalues" id="refsect1-reflectionclass.marklazyobjectasinitialized-returnvalues">
  <h3 class="title">戻り値</h3>
  <p class="simpara">
   <code class="parameter">object</code> を返します。
  </p>
 </div>


 <div class="refsect1 examples" id="refsect1-reflectionclass.marklazyobjectasinitialized-examples">
  <h3 class="title">例</h3>
  <div class="example" id="example-5360">
   <p><strong>例1 未初期化のレイジーオブジェクトを初期化済みとしてマークする</strong></p>
   <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br /></span><span style="color: #007700">class </span><span style="color: #0000BB">Example<br /></span><span style="color: #007700">{<br />    public </span><span style="color: #0000BB">string $prop1</span><span style="color: #007700">;<br />    public </span><span style="color: #0000BB">string $prop2</span><span style="color: #007700">;<br />    public </span><span style="color: #0000BB">string $prop3 </span><span style="color: #007700">= </span><span style="color: #DD0000">'default value'</span><span style="color: #007700">;<br />}<br /><br /></span><span style="color: #0000BB">$reflector </span><span style="color: #007700">= new </span><span style="color: #0000BB">ReflectionClass</span><span style="color: #007700">(</span><span style="color: #0000BB">Example</span><span style="color: #007700">::class);<br /><br /></span><span style="color: #0000BB">$object </span><span style="color: #007700">= </span><span style="color: #0000BB">$reflector</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">newLazyGhost</span><span style="color: #007700">(function (</span><span style="color: #0000BB">$object</span><span style="color: #007700">) {<br />    echo </span><span style="color: #DD0000">"Initializer called\n"</span><span style="color: #007700">;<br />    </span><span style="color: #0000BB">$object</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">prop1 </span><span style="color: #007700">= </span><span style="color: #DD0000">'initialized'</span><span style="color: #007700">;<br />});<br /><br /></span><span style="color: #0000BB">$reflector</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">getProperty</span><span style="color: #007700">(</span><span style="color: #DD0000">'prop1'</span><span style="color: #007700">)<br />          -&gt;</span><span style="color: #0000BB">setRawValueWithoutLazyInitialization</span><span style="color: #007700">(</span><span style="color: #0000BB">$object</span><span style="color: #007700">, </span><span style="color: #DD0000">'prop1 value'</span><span style="color: #007700">);<br /><br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">$object</span><span style="color: #007700">);<br /><br /></span><span style="color: #0000BB">$reflector</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">markLazyObjectAsInitialized</span><span style="color: #007700">(</span><span style="color: #0000BB">$object</span><span style="color: #007700">);<br /><br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">$object</span><span style="color: #007700">);<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
   </div>

   <div class="example-contents"><p>上の例の出力は以下となります。</p></div>
   <div class="example-contents screen">
<div class="examplescode"><pre class="examplescode">lazy ghost object(Example)#3 (1) {
  [&quot;prop1&quot;]=&gt;
  string(11) &quot;prop1 value&quot;
  [&quot;prop2&quot;]=&gt;
  uninitialized(string)
  [&quot;prop3&quot;]=&gt;
  uninitialized(string)
}
object(Example)#3 (2) {
  [&quot;prop1&quot;]=&gt;
  string(11) &quot;prop1 value&quot;
  [&quot;prop2&quot;]=&gt;
  uninitialized(string)
  [&quot;prop3&quot;]=&gt;
  string(13) &quot;default value&quot;
}</pre>
</div>
   </div>
  </div>
  <div class="example" id="example-5361">
   <p><strong>例2 既に初期化されたオブジェクトを初期化済みとしてマークする</strong></p>
   <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br /></span><span style="color: #007700">class </span><span style="color: #0000BB">Example<br /></span><span style="color: #007700">{<br />    public </span><span style="color: #0000BB">string $prop1</span><span style="color: #007700">;<br />    public </span><span style="color: #0000BB">string $prop2</span><span style="color: #007700">;<br />    public </span><span style="color: #0000BB">string $prop3 </span><span style="color: #007700">= </span><span style="color: #DD0000">'default value'</span><span style="color: #007700">;<br />}<br /><br /></span><span style="color: #0000BB">$reflector </span><span style="color: #007700">= new </span><span style="color: #0000BB">ReflectionClass</span><span style="color: #007700">(</span><span style="color: #0000BB">Example</span><span style="color: #007700">::class);<br /><br /></span><span style="color: #0000BB">$object </span><span style="color: #007700">= </span><span style="color: #0000BB">$reflector</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">newLazyGhost</span><span style="color: #007700">(function (</span><span style="color: #0000BB">$object</span><span style="color: #007700">) {<br />    echo </span><span style="color: #DD0000">"Initializer called\n"</span><span style="color: #007700">;<br />    </span><span style="color: #0000BB">$object</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">prop1 </span><span style="color: #007700">= </span><span style="color: #DD0000">'initialized'</span><span style="color: #007700">;<br />});<br /><br /></span><span style="color: #0000BB">$reflector</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">getProperty</span><span style="color: #007700">(</span><span style="color: #DD0000">'prop1'</span><span style="color: #007700">)<br />          -&gt;</span><span style="color: #0000BB">setRawValueWithoutLazyInitialization</span><span style="color: #007700">(</span><span style="color: #0000BB">$object</span><span style="color: #007700">, </span><span style="color: #DD0000">'prop1 value'</span><span style="color: #007700">);<br /><br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">$object</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">prop3</span><span style="color: #007700">);<br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">$object</span><span style="color: #007700">);<br /><br /></span><span style="color: #0000BB">$reflector</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">markLazyObjectAsInitialized</span><span style="color: #007700">(</span><span style="color: #0000BB">$object</span><span style="color: #007700">);<br /><br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">$object</span><span style="color: #007700">);<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
        </div>

        <div class="example-contents"><p>上の例の出力は以下となります。</p></div>
        <div class="example-contents screen">
<div class="examplescode"><pre class="examplescode">Initializer called
string(13) &quot;default value&quot;
object(Example)#3 (2) {
  [&quot;prop1&quot;]=&gt;
  string(11) &quot;initialized&quot;
  [&quot;prop2&quot;]=&gt;
  uninitialized(string)
  [&quot;prop3&quot;]=&gt;
  string(13) &quot;default value&quot;
}
object(Example)#3 (2) {
  [&quot;prop1&quot;]=&gt;
  string(11) &quot;initialized&quot;
  [&quot;prop2&quot;]=&gt;
  uninitialized(string)
  [&quot;prop3&quot;]=&gt;
  string(13) &quot;default value&quot;
}</pre>
</div>
   </div>
  </div>
 </div>


 <div class="refsect1 seealso" id="refsect1-reflectionclass.marklazyobjectasinitialized-seealso">
  <h3 class="title">参考</h3>
  <ul class="simplelist">
   <li><a href="language.oop5.lazy-objects.php" class="link">レイジーオブジェクト</a></li>
   <li><span class="methodname"><a href="reflectionclass.newlazyghost.php" class="methodname" rel="rdfs-seeAlso">ReflectionClass::newLazyGhost()</a> - 新しいレイジーゴーストインスタンスを作成する</span></li>
   <li><span class="methodname"><a href="reflectionclass.initializelazyobject.php" class="methodname" rel="rdfs-seeAlso">ReflectionClass::initializeLazyObject()</a> - レイジーオブジェクトを強制的に初期化する</span></li>
   <li><span class="methodname"><a href="reflectionclass.isuninitializedlazyobject.php" class="methodname" rel="rdfs-seeAlso">ReflectionClass::isUninitializedLazyObject()</a> - オブジェクトがレイジーで未初期化かどうかを調べる</span></li>
  </ul>
 </div>


</div><?php manual_footer($setup); ?>